-- $Id: load.lua 4651 2023-07-21 00:08:22Z dsb $
-- ToME - Tales of Maj'Eyal
-- Copyright © 2023 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham ("Zizzo")
-- dsb-tome@killerbunnies.org

require 'Json2'

local function dumpJSON()
  -- Slight Hack(TM):  This roughly mimics
  -- engine.interface.PlayerDumpJSON:saveUUID() [q.v.] to "manually" dump
  -- the character to JSON
  local data = {sections={}}
  setmetatable(data, {__index={
    version = function(self, v) self.version = v end,
    hiddenData = function(self, key, value)
      self.hidden = self.hidden or {}
      self.hidden[key] = value
    end,
    newSection = function(self, table, sectable)
      self.sections[#self.sections+1] = table
      self[table] = sectable or {}
      return self[table]
    end,
    subsheet = function(self, name)
      local s = {sections={}}
      setmetatable(s, getmetatable(self))
      self.subsheets = self.subsheets or {}
      self.subsheets[#self.subsheets+1] = {name=name, sheet=s}
      return s
    end,
  }})
  local title, tags = game.player:dumpToJSON(data)
  print(('[JSON] test dump: title="%s"'):format(title))
  print('[JSON] test dump: tags:')
  table.print(tags)
  print('[JSON] test dump: Lua data for JSON conversion:')
  table.print(data)
  print('[JSON] test dump: converted JSON data:')
  print(json.encode(data))
end

class:bindHook("ToME:runDone", function(self, data)
  -- If we're using the addon on an existing character.
  if not game.creating_player then dumpJSON() end
end)

class:bindHook("ToME:birthDone", function(self, data)
  -- If we're creating a new character with this addon.
  if game.player then dumpJSON() end
end)
